#ifndef __GSK_LISP_MARSHAL_H_
#define __GSK_LISP_MARSHAL_H_

#include "gsklispnamespace.h"

gboolean gsk_lisp_compile_list_from_arg_spec      (GskLispNode      *node,
					           GskLispArgSpec   *arg_spec,
					           GskLispNamespace *ns,
					           GSList          **list_out,
					           char            **err_msg);
gboolean gsk_lisp_compile_ptr_array_from_arg_spec (GskLispNode      *node,
					           GskLispArgSpec   *arg_spec,
					           GskLispNamespace *ns,
					           GPtrArray       **array_out,
					           char            **err_msg);
void     gsk_lisp_codec_array_destroy (GPtrArray*);
void     gsk_lisp_codec_slist_destroy (GSList*);

extern GskLispMarshal gsk_lisp_marshal_DOUBLE__INT;
extern GskLispMarshal gsk_lisp_marshal_INT__DOUBLE;

extern GskLispMarshal gsk_lisp_marshal_NONE__NONE;
extern GskLispMarshal gsk_lisp_marshal_NONE__UINT;
extern GskLispMarshal gsk_lisp_marshal_INT__INT_INT;
extern GskLispMarshal gsk_lisp_marshal_BOOL__INT_INT;
extern GskLispMarshal gsk_lisp_marshal_BOOL__BOOL;

/* func == int (*func)(guint num_ints, const gint *ints)  */
extern GskLispMarshal gsk_lisp_marshal_INT__INTARRAY;

#ifndef GSK_DEBUG
#define gsk_lisp_arg_spec_make_perm gsk_lisp_arg_spec_make
#endif

#endif
